
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

#include <conio.h>
#include <direct.h>

#pragma warning(disable: 4996)

typedef struct _event_rec {
	char starttimec[16];
	char endtimec[16];
	char offsetc[16];
	char viewc[16];
	char imagec[256];
} event_rec;

extern event_rec Events[];
extern	char defaultoffsetc[];
extern	char resolutionc[];

int eventcount = 0;
int matchchar(char f[], char q[], int p);

bool Load_Xml(TCHAR *xmlpath)
{
	long fsize;
	FILE *fp;

	fp = _tfopen(xmlpath, _T("r"));
	if (fp == NULL)
	{
		fprintf(stderr, "Error: xml file \"%s\" opening faild\n", xmlpath);
		getch();
		goto error_return;
	}
	fseek(fp, 0, SEEK_END);
	fsize = ftell(fp);
	char *xml = (char *)malloc(fsize+32);
	fseek(fp, 0, SEEK_SET);

	if (fread(xml, 1, fsize, fp) < fsize) {
		fprintf(stderr, "Error: xml file \"%s\" read faild\n", xmlpath);
		fclose(fp);
		goto error_return;
	}
	fclose(fp);

	int tagquo, tagtype;
	tagquo = 0;
	tagtype = 0;
	
	char *writer;
	int targetpoint;

	char *dummy=(char *)malloc(65536);
	writer = dummy;

	targetpoint = 0;
	defaultoffsetc[0] = 0;

	char q[32], a;
	int knowntag;
	int jumpquo;
	jumpquo = 0;
	knowntag = 0;
	int i;
	printf("Info: parsing xml ...\n");

	for(i = 0; i < fsize; i++)
	{
		if(xml[i] == '<' && tagquo == 0)
		{
			knowntag = 0;
			tagquo = 1;
			if(matchchar(xml, "<pgssup", i) && (xml[i + 7] == ' ' || xml[i + 7] == '>'))
			{
				if(tagtype == 0)
				{
					tagtype = 1;
					knowntag = 1;
				}
				else
				{
					printf("Error: the pgssup tag should be in the root\n");
					goto error_return;
				}
			}
			if(matchchar(xml, "<subtitle", i) && (xml[i + 9] == ' ' || xml[i + 9] == '>'))
			{
				if(tagtype == 1)
				{
					tagtype = 2;
					knowntag = 1;
				}
				else
				{
					printf("Error: the subtitle tag should be in the pgssup tag\n");
					goto error_return;
				}
				eventcount++;
			}
			if(matchchar(xml, "</subtitle>", i))
			{
				if(tagtype == 2)
				{
					tagtype = 1;
					knowntag = 1;
				}
				else
				{
					printf("Error: XML syntax is wrong\n");
					goto error_return;
				}
			}
			if(matchchar(xml, "</pgssup>", i))
			{
				if(tagtype == 1)
				{
					tagtype = 0;
					knowntag = 1;
				}
				else
				{
					printf("Error: XML syntax is wrong\n");
					goto error_return;
				}
			}
			if(!knowntag)
			{
				printf("Error: unknown tag\n");
				goto error_return;
			}
		}
		if(xml[i - 1] == '"' && tagquo == 1 && jumpquo == 0)
		{
			tagquo = 2;
			if(tagtype == 1 && matchchar(xml, " defaultoffset=", i - 16))
			{
				targetpoint = 0;
				writer = defaultoffsetc;
			}
			if(tagtype == 1 && matchchar(xml, " resolution=", i - 13))
			{
				targetpoint = 0;
				writer = resolutionc;
			}
			if(tagtype == 2 && matchchar(xml, " starttime=", i - 12))
			{
				targetpoint = 0;
				writer = Events[eventcount - 1].starttimec;
			}
			if(tagtype == 2 && matchchar(xml, " endtime=", i - 10))
			{
				targetpoint = 0;
				writer = Events[eventcount - 1].endtimec;
			}
			if(tagtype == 2 && matchchar(xml, " offset=", i - 9))
			{
				targetpoint = 0;
				writer = Events[eventcount - 1].offsetc;
			}
			if(tagtype == 2 && matchchar(xml, " view=", i - 7))
			{
				targetpoint = 0;
				writer = Events[eventcount - 1].viewc;
			}
			if(tagtype == 2 && matchchar(xml, " image=", i - 8))
			{
				targetpoint = 0;
				writer = Events[eventcount - 1].imagec;
			}
		}
		if(jumpquo == 1)
			jumpquo = 0;
		if(xml[i] == '"' && tagquo == 2)
		{
			tagquo = 1;
			writer[targetpoint] = 0;
			writer = dummy;
			jumpquo = 1;
		}
		if(xml[i] == '>' && tagquo == 1)
		{
			tagquo = 0;
			if(xml[i - 1] =='/')
			{
				tagtype--;
			}
		}
		writer[targetpoint] = xml[i];
		targetpoint++;
	}
	if(tagtype != 0)
	{
		printf("Error: XML is not valid\n");
		goto error_return;
	}
	if(tagquo != 0)
	{
		printf("Error: XML is not valid\n");
		goto error_return;
	}
	printf("Info: loading xml completed\n\n");

	if (dummy)
		free(dummy);
	if (xml)
		free(xml);
	return true;

error_return:
	if (dummy)
		free(dummy);
	if (xml)
		free(xml);
	return false;

}

int matchchar(char f[], char q[], int p)
{
	int c;
	c = 0;
	while(1)
	{
		if(q[c] == 0)
			return(1);
		if(f[p + c] != q[c])
			return(0);
		c++;
	}
}

