// pgssup.cpp : R\[ AvP[ṼGg |Cg`܂B
//
/* Copyright notice-
 * pgssup for windows, rewritten by swallow.
 * pgssup was originally written by Koichi Akabe 2009 <mail@vbkaisetsu.com>
 * under GNU LGPL.
 * But, most of original codes were rewritten for readability, so LGPL
 * license is unclear. In adition, windows version uses winAPI GDI+ rather
 * than libpng. Maybe it's outside of the GPL.
 */
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <direct.h>
#include <tchar.h>

#pragma warning(disable: 4996)

bool Load_Xml(TCHAR *xmlpath);
int png_load(_TCHAR *infile);
void png_unload();
int build_palette();
int build_RLE();
void set_timecode(long start, long end);
void write_present_def1(FILE *ofp);
void write_window_def1(FILE *ofp);
void write_palette_def(FILE *ofp);
void write_bitmap_def(FILE* ofp);
void write_displayset_end1(FILE* ofp);
void write_present_def2(FILE *ofp);
void write_window_def2(FILE *ofp);
void write_displayset_end2(FILE* ofp);

void help()
{
	printf("Syntax: pgssup <xmlfile> \n");
	printf("\n");
	printf("XML structure:\n");
	printf("\n");
	printf("FOR EXAMPLE\n");
	printf("<pgssup resolution=\"1920,1080\"defaultoffset=\"0,920\">\n");
	printf("    <subtitle starttime=\"00:00:54.384\" endtime=\"00:00:56.932\" image=\"/home/hoge/sub00000.png\" />\n");
	printf("    <subtitle starttime=\"00:00:59.837\" endtime=\"00:01:01.411\" offset=\"1000,50\" image=\"/home/hoge/sub00001.png\" />\n");
	printf("    <subtitle starttime=\"00:01:10.734\" endtime=\"00:01:12.638\" view=\"forced\" image=\"/home/hoge/sub00002.png\" />\n");
	printf("</pgssup>\n");
	printf("\n");
	printf("resolution:    Resolution of video stream\n");
	printf("defaultoffset: Default offset of subtitles. If the offset of subtitles is null, this value will set to the subtitle. (default=0,0)\n");
	printf("offset:        the position of subtitle on the display.\n");
	printf("view:          Subtitles will be forced to display if this property is \"forced\".\n");
	printf("image:         This image should have less than 256 colors.\n");
	printf("\n");
}

char defaultoffsetc[16];
char resolutionc[16];

typedef struct _event_rec {
	char starttimec[16];
	char endtimec[16];
	char offsetc[16];
	char viewc[16];
	char imagec[256];
} event_rec;

#define MAX_EVENTS 16384
event_rec Events[MAX_EVENTS];


_TCHAR	HOME[1000];
_TCHAR  WORK[1000];
_TCHAR  TARGET[256];

_TCHAR xmlpath[1000];
_TCHAR outpath[1000];
_TCHAR pngfile[256];
FILE *pngfp;

int offsetx, offsety, onoff;

int _tmain(int argc, _TCHAR* argv[])
{
	int i;
	extern int width, height;
	

	printf("==============================================\n");
	printf("| PGSSUP for windows version 0.1             |\n");
	printf("| rewritten by swallow                       |\n");
	printf("| Last modified: 2010-07-13 (YYYY-MM-DD)     |\n");
	printf("| License: ?? Open Souce ??                  |\n");
	printf("==============================================\n");
	printf("\n");
	Sleep(3000);

	width = 1920;
	height = 1080;
#ifdef _DEBUG
	argc = 2;
	argv[1] = _T("C:\\Users\\YOUR_NAME\\Videos\\Sample.xml");
#endif

	_tsplitpath(argv[0], HOME, &HOME[2], NULL, NULL);

	if(argc != 2)
	{
		printf("usage: pgssup.exe src.xml\n");
		Sleep(3000);
		return 1;
	} else if(_tcscmp(argv[1], _T("-h")) == 0) {
		help();
		getch();
		return 0;
	}

	_tsplitpath(argv[1], WORK, &WORK[2], TARGET, NULL);
	_tcscpy(xmlpath, argv[1]);
	_tcscpy(outpath, WORK);
	_tcscat(outpath, TARGET);
	_tcscat(outpath, _T(".sup"));

	_tchdir(HOME);
	
	if (Load_Xml(xmlpath) == false)
		return 1;

	int h1, m1, s1, ms1, h2, m2, s2, ms2;
	int default_offsetx, default_offsety;
	long _starttime, _endtime;

	sscanf(defaultoffsetc, "%d,%d", &default_offsetx, &default_offsety);
	sscanf(resolutionc, "%d,%d", &width, &height);

	FILE *fp;
	if ((fp = _tfopen(outpath, _T("wb"))) == NULL)
	{
		printf("Error: the sup file \"%s\" could not be opened\n", outpath);
		getch();
		return(0);
	}
	void init_png_load();		// GDI+ thing
	void finish_png_load();

	init_png_load();			// Setup GDI+
	extern int eventcount;
	for(i = 0; i < eventcount; i++)
	{
		sscanf(Events[i].starttimec, "%2d:%2d:%2d.%3d", &h1, &m1, &s1, &ms1);
		sscanf(Events[i].endtimec, "%2d:%2d:%2d.%3d", &h2, &m2, &s2, &ms2);
		sscanf(Events[i].imagec, "%s", pngfile);
		sscanf(Events[i].offsetc, "%d,%d", &offsetx, &offsety);
		if(Events[i].offsetc[0] == '\0')
		{
			offsetx = default_offsetx;
			offsety = default_offsety;
		}
		if(strcmp(Events[i].viewc, "forced")==0)
		{
			onoff = 1;
			printf("Info: including subtitle %d... (%d:%02d:%02d.%03d - %d:%02d:%02d.%03d forced)\n", 
				i + 1, h1, m1, s1, ms1, h2, m2, s2, ms2);
		}
		else
		{
			onoff = 0;
			printf("Info: including subtitle %d... (%d:%02d:%02d.%03d - %d:%02d:%02d.%03d)\n", 
				i + 1, h1, m1, s1, ms1, h2, m2, s2, ms2);
		}
		_starttime = h1 * 3600000 + m1 * 60000 + s1 * 1000 + ms1;
		_endtime = h2 * 3600000 + m2 * 60000 + s2 * 1000 + ms2;

		_TCHAR path[1000];
		_tcscpy(path, WORK);
		_tcscat(path, pngfile);

		// Load PNG and write SUP data
		if (png_load(path) == 0)
			continue;
		if (build_palette() == 0)
			;//continue;
		if (build_RLE() == 0)
			continue;

		set_timecode(_starttime, _endtime);

		// start presentation
		write_present_def1(fp);
		write_window_def1(fp);
		write_palette_def(fp);
		write_bitmap_def(fp);
		write_displayset_end1(fp);

		// stop presentation
		write_present_def2(fp);
		write_window_def2(fp);
		write_displayset_end2(fp);

		png_unload();

		extern int bmplength;

		printf("Info: subtitle %d was included (bitmap: %d bytes)...\n\n", i + 1, bmplength);
	}
	fclose(fp);
	finish_png_load();		// Cleanup GDI+
	printf("Complete !\n");
	Sleep(3000);
	return(0);
}

