#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <tchar.h>

#include <gdiplus.h>
#include <gdiplusBitmap.h>
#include <Gdiplusgraphics.h> 
#include <Gdiplusheaders.h> 


using namespace Gdiplus;

#pragma warning(disable: 4996)

ULONG_PTR m_Token;

void init_png_load()
{
	Gdiplus::GdiplusStartupInput m_StartupInput;
	UINT m_NumEncoders;
	Gdiplus::ImageCodecInfo* m_pEncoders;

	// GDI+̏
	Gdiplus::GdiplusStartup(&m_Token, &m_StartupInput, NULL);
	// GR[_̏
	UINT size = 0;
	Gdiplus::GetImageEncodersSize(&m_NumEncoders, &size);
	m_pEncoders = (Gdiplus::ImageCodecInfo*)malloc(size);
	Gdiplus::GetImageEncoders(m_NumEncoders, size, m_pEncoders);
}

void finish_png_load()
{
	Gdiplus::GdiplusShutdown(m_Token);
}
unsigned char *bmbuff;
unsigned char **pixel;

int png_w, png_h;

int png_load(_TCHAR *pngfile)
{
	WCHAR path[1000];

#ifdef  _UNICODE
	wcscpy(path, pngfile);
#else
	MultiByteToWideChar(CP_UTF8, 0, pngfile, -1, path, 1000);
#endif
	Bitmap *bmp = Bitmap::FromFile(path, 0);
	if (bmp == NULL)
		return 0;
	if (bmp->GetPixelFormat() != PixelFormat32bppARGB)
		return 0;

	png_w = bmp->GetWidth();
	png_h = bmp->GetHeight();
	BitmapData bmpData; 
	Rect rect  = Rect(0, 0, png_w, png_h);
	int stride;
	unsigned char *ptr;

	bmp->LockBits(&rect, ImageLockModeWrite | ImageLockModeRead , PixelFormat32bppARGB, &bmpData);
	ptr = (unsigned char *)bmpData.Scan0;
	stride = abs(bmpData.Stride);
	if (stride != png_w*4)	// this is always false in PixelFormat32bppARGB
		return 0;

	bmbuff = (unsigned char *)calloc(png_w * png_h, sizeof(__int32));
	pixel = (unsigned char **)calloc(png_h, sizeof(unsigned char *));
	for(int j = 0; j < png_h; j++)
		pixel[j] = bmbuff + png_w* 4 * j;
	
	for (int y = 0; y < png_h; y++) {
		for (int x = 0; x < png_w; x++) {
			// bmp[bgra] --> png[rgba]
			bmbuff[y*png_w*4 +x*4 + 2] = ptr[y*png_w*4 +x*4 + 0];
			bmbuff[y*png_w*4 +x*4 + 1] = ptr[y*png_w*4 +x*4 + 1];
			bmbuff[y*png_w*4 +x*4 + 0] = ptr[y*png_w*4 +x*4 + 2];
			bmbuff[y*png_w*4 +x*4 + 3] = ptr[y*png_w*4 +x*4 + 3];
		}
	}
	bmp->UnlockBits(&bmpData);
	delete(bmp);
	return (png_w * png_h * sizeof(__int32));
}

void png_unload()
{
	free(pixel);
	free(bmbuff);
}


