

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <direct.h>
#include <tchar.h>


#pragma warning(disable: 4996)


/*
-------------
'PG', PTS, 0,0,0,0, (start time)
0x16, ... presentation composition definition (0x13 bytes)
0x17, ... window definition (0x0A bytes)
0x14, ... palette definition (0x4F8 bytes)
0x15, ... object definition (0x3087 bytes)
0x80, 0, 0 end of displayset
'PG', PTS, 0,0,0,0, (end time)
0x16, ... presentation composition definition 0x0B
0x17, ... window definition 0x0A
0x80, 0, 0 end of displayset
-------------

------------1----------
00000002: PTS=005B7DE2 (00:01:06,622)
0000000A: PCS (13) state: 2
0000002A: WDS1 (0A) id: 0 [674,876] - [1254,1025]
00000041: PDS (142) 64 palettes
00000190: ODS (6931) 580 x 149
00006ACE: END
00006AD3: PTS=006012EE (00:01:09,959)
00006ADB: PCS (0B) state: 0
00006AF3: WDS1 (0A) id: 0 [674,876] - [1254,1025]
00006B0A: END

*/

#pragma pack(push,1)

typedef struct _Present_Def {	//presentation composition definition 
unsigned short	PG;				//2
unsigned long	PTS;			//6		PTS
unsigned long	DTS;			//10	starttime - 5832 DTS
unsigned char	kind;			//11 0x16
unsigned short	sect_size;		//13 0x0013 //sizeof section
unsigned short	width;			//15
unsigned short	height;			//17
unsigned char	reserved_1;		//18 0x40
unsigned short	reserved_2;		//20 0x0000
unsigned short	reserved_3;		//22 0x8000
unsigned char	reserved_4;		//23 0x00
unsigned long	reserved_5;		//27 0x0100001
unsigned char	force;			//28
unsigned short	offsetx;		//30
unsigned short	offsety;		//32
} _Present_Def;

typedef struct _Window_Def {	//window definition 
unsigned short	PG;				//2
unsigned long	PTS;			//6		starttime - 90
unsigned long	DTS;			//10	starttime - 5832
unsigned char	kind;			//11 0x17
unsigned short	sect_size;		//13 0x000A
unsigned short	reserved_1;		//15 0x0001
unsigned short	offsetx;		//17
unsigned short	offsety;		//19
unsigned short	png_w;			//21
unsigned short	png_h;			//23
} _Window_Def;

typedef struct _Palette_Def {
unsigned short	PG;				//2
unsigned long	PTS;			//6		starttime - 5832
unsigned long	DTS;			//10 0x00000000
unsigned char	kind;			//11 0x14
unsigned short	palette_length;	//13 (pallette count)*5+2 (2 for reserved_1) bytes
unsigned short	reserved_1;		//15 0x0000
} _Palette_Def;

typedef struct _Bitamp_Def {
unsigned short	PG;				//2		
unsigned long	PTS;			//6		starttime - 5643
unsigned long	DTS;			//10	starttime - 5832
unsigned char	kind;			//11 0x15
unsigned short	bmplength;		//13 bmplength
unsigned short	reserved_1;		//15 0x0000
unsigned short	reserved_2;		//17 0x00C0
unsigned char	reserved_3;		//18 0x00
unsigned short	bmplength2;		//20 bmplength -7 (?? bmplength -5??)
unsigned short	png_w;			//22
unsigned short	png_h;			//24
} _Bitamp_Def;

typedef struct _Displayset_End {	// end of displayset
unsigned short	PG;					//2
unsigned long	PTS;				//6		endtime - 90
unsigned long	DTS;				//10 0x00000000
unsigned char	kind;				//11 0x80
unsigned short	sect_size;			//13 0x0000
} _Displayset_End;

#pragma pack(pop)

// endiansawped initialyzers
_Present_Def		present_def =		{'GP', 0, 0, 0x16, 0x1300, 0, 0, 0x40, 0x0000, 0x0080, 0, 0x01000001, 0, 0, 0};
_Window_Def			window_def =		{'GP', 0, 0, 0x17, 0x0A00, 0x0100, 0, 0, 0, 0};
_Palette_Def		palette_def =		{'GP', 0, 0, 0x14, 0, 0};
_Bitamp_Def			bitmap_def =		{'GP', 0, 0, 0x15, 0, 0, 0xC000, 0x00, 0, 0, 0};
_Displayset_End		displayset_end =	{'GP', 0, 0, 0x80, 0};

#define be32(x) ((((DWORD)(x) & 0xFF) << 24) |     \
                  (((DWORD)(x) & 0xFF00) << 8) |    \
                  (((DWORD)(x) & 0xFF0000) >> 8) |  \
                  (((DWORD)(x) & 0xFF000000) >> 24))

#define be16(x) ((((WORD)(x) & 0xFF00) >> 8) |	\
					(((WORD)(x) & 0x00FF) << 8))


int width, height;
long starttime, endtime;
long time1, time2, time3, time4;

extern	int offsetx, offsety, onoff;

void set_timecode(long start, long end)
{
	starttime = start;
	endtime = end;

	starttime *= 90.090;
	time1 = starttime - 5832;
	time2 = starttime - 90;
	time3 = starttime - 5643;
	endtime *= 90.090;
	time4 = endtime - 90;
}

void write_present_def1(FILE *ofp)
{	// 0x16
	present_def.PTS = be32(starttime);
	present_def.DTS= be32(time1);
	present_def.width = be16(width);
	present_def.height = be16(height);
	if(onoff != 0)
		present_def.force = 0x40;
	else
		present_def.force = 0;
	present_def.offsetx = be16(offsetx);
	present_def.offsety = be16(offsety);
			
	//something internal issue
	present_def.sect_size = be16(0x0013); // 0x0013 or 0x000b
	present_def.reserved_2 = 0x0000;
	present_def.reserved_3 = be16((short)0x8000);
	present_def.reserved_5 = be32(0x01000001); //0x01000001

	fwrite(&present_def, 1, sizeof(present_def), ofp);
}

void write_window_def1(FILE *ofp)
{
	// 0x17
	extern int png_w, png_h;
	window_def.PTS =  be32(time2);
	window_def.DTS = be32(time1);
	window_def.offsetx = be16(offsetx);
	window_def.offsety = be16(offsety); 
	window_def.png_w = be16(png_w);
	window_def.png_h = be16(png_h);

	fwrite(&window_def, 1, sizeof(window_def), ofp);
}


unsigned char palette_r[256];
unsigned char palette_g[256];
unsigned char palette_b[256];
unsigned char palette_a[256];
extern unsigned char **pixel, *bmbuff;
extern int png_w, png_h;

int palette_count = 0;

int build_palette()
{

	int aflag = 0;
	int x, y, j;
	extern _TCHAR pngfile[];
	void do_neuquant(unsigned char *buff, int png_w, int png_h);

	palette_count = 0;

	// checking color palette
	for(j = 0; j < 256; j++)
	{
		palette_r[j] = 0;
		palette_g[j] = 0;
		palette_b[j] = 0;
		palette_a[j] = 0;
	}
	for(y = 0; y < png_h; y++)
	{
		for(x = 0; x < png_w; x++)
		{
			if(pixel[y][x * 4 + 3] == 0)
			{
				aflag = 1;
				continue;
			}
			for(j = 0; j < palette_count; j++)
			{
				if(
				   palette_r[j] == pixel[y][x * 4] &&
				   palette_g[j] == pixel[y][x * 4 + 1] &&
				   palette_b[j] == pixel[y][x * 4 + 2] &&
				   palette_a[j] == pixel[y][x * 4 + 3]
				   )
					break;
			}
			if(j == palette_count)
			{
				if(palette_count == 256)
					break;
				palette_r[palette_count] = pixel[y][x * 4];
				palette_g[palette_count] = pixel[y][x * 4 + 1];
				palette_b[palette_count] = pixel[y][x * 4 + 2];
				palette_a[palette_count] = pixel[y][x * 4 + 3];
				palette_count++;
			}
		}
		if(palette_count == 256)
			break;
	}
	if (aflag == 1 && palette_count == 256)
		do_neuquant((unsigned char*)bmbuff, png_w, png_h);		// decrease to 256 color

	aflag = 0;
	palette_count = 0;
	// creating color palette
	for(j = 0; j < 256; j++)
	{
		palette_r[j] = 0;
		palette_g[j] = 0;
		palette_b[j] = 0;
		palette_a[j] = 0;
	}
	for(y = 0; y < png_h; y++)
	{
		for(x = 0; x < png_w; x++)
		{
			if(pixel[y][x * 4 + 3] == 0)
			{
				aflag = 1;
				continue;
			}
			for(j = 0; j < palette_count; j++)
			{
				if(
				   palette_r[j] == pixel[y][x * 4] &&
				   palette_g[j] == pixel[y][x * 4 + 1] &&
				   palette_b[j] == pixel[y][x * 4 + 2] &&
				   palette_a[j] == pixel[y][x * 4 + 3]
				   )
					break;
			}
			if(j == palette_count)
			{
				if(palette_count == 256)
				{
					printf("Error: the png file \"%s\" has more than 256 colors\n", pngfile);
					getch();
					return(0);
				}
				palette_r[palette_count] = pixel[y][x * 4];
				palette_g[palette_count] = pixel[y][x * 4 + 1];
				palette_b[palette_count] = pixel[y][x * 4 + 2];
				palette_a[palette_count] = pixel[y][x * 4 + 3];
				palette_count++;
			}
		}
	}
	if(aflag == 1 && palette_count == 256)
	{
		printf("Error: the png file \"%s\" has more than 256 colors\n", pngfile);
		getch();
		return(0);
	}
	printf("Info: the png file \"%s\" has %d color(s); size: %dx%d\n", pngfile, palette_count, (int)png_w, (int)png_h);
	return palette_count;
}

void write_palette_def(FILE *ofp)
{
	// 0x14
	{
		palette_def.PTS = be32(time1);
		palette_def.DTS = 0;
		palette_def.palette_length = be16(palette_count * 5 + 2);

		fwrite(&palette_def, 1, sizeof(palette_def), ofp);
	}
	unsigned char palettedata[256*5+2];
	int paletteindex = 0;
	int j;
	for(j = 0; j < palette_count; j++)
	{
		signed char Cr, Cb;
		unsigned char Y;
		// RGB -> YCrCb
		Y = 0.299 * (double)palette_r[j] + 0.587 * (double)palette_g[j] + 0.114 * (double)palette_b[j];
		Cr = 0.5 * (double)palette_r[j] - 0.419 * (double)palette_g[j] - 0.081 * (double)palette_b[j];
		Cb = -0.169 * (double)palette_r[j] - 0.332 * (double)palette_g[j] + 0.5 * (double)palette_b[j];
		palettedata[paletteindex] = j;
		palettedata[paletteindex + 1] = Y;
		palettedata[paletteindex + 2] = Cr + 128;
		palettedata[paletteindex + 3] = Cb + 128;
		palettedata[paletteindex + 4] = palette_a[j];
		paletteindex += 5;
	}
	fwrite(&palettedata, 1, paletteindex, ofp);
}

unsigned char RLEdata[67000];
int bmplength;

int build_RLE()
{
	int prevpalette;
	int colorseqcount;
	int x, y, j;

	// Run Length Encoding scheme
	bmplength = 0;
	for(y = 0; y < png_h; y++)
	{
		colorseqcount = 1;
		for(j = 0; j < palette_count; j++)
		{
			if(
			   palette_r[j] == pixel[y][0] &&
			   palette_g[j] == pixel[y][1] &&
			   palette_b[j] == pixel[y][2] &&
			   palette_a[j] == pixel[y][3]
			   )
				break;
		}
		prevpalette = j;
		if(pixel[y][3] == 0)
			prevpalette = 0xff;
		for(x = 1; x < png_w; x++)
		{
			for(j = 0; j < palette_count; j++)
			{
				if(
				   palette_r[j] == pixel[y][x * 4 + 0] &&
				   palette_g[j] == pixel[y][x * 4 + 1] &&
				   palette_b[j] == pixel[y][x * 4 + 2] &&
				   palette_a[j] == pixel[y][x * 4 + 3]
				   )
					break;
			}
			if(pixel[y][x * 4 + 3] == 0)
				j = 0xff;
			if(j == prevpalette)
			{
				colorseqcount++;
				continue;
			}
			else
			{
				int k;
				k = (double)colorseqcount / 256;
				if(colorseqcount >= 0x40)
				{
					if(prevpalette != 0)
					{
						RLEdata[bmplength] = 0x00;
						RLEdata[bmplength + 1] = k + 0xC0;
						RLEdata[bmplength + 2] = colorseqcount - k * 256;
						RLEdata[bmplength + 3] = prevpalette;
						bmplength += 4;
					}
					else
					{
						RLEdata[bmplength] = 0x00;
						RLEdata[bmplength + 1] = k + 0x40;
						RLEdata[bmplength + 2] = colorseqcount - k * 256;
						bmplength += 3;
					}
				}
				else
				{
					if(prevpalette != 0)
					{
						if(prevpalette <= 0x39 && colorseqcount == 1)
						{
							RLEdata[bmplength] = prevpalette;
							bmplength += 1;
						}
						else if(prevpalette <= 0x39 && colorseqcount == 2)
						{
							RLEdata[bmplength] = prevpalette;
							RLEdata[bmplength + 1] = prevpalette;
							bmplength += 2;
						}
						else
						{
							RLEdata[bmplength] = 0x00;
							RLEdata[bmplength + 1] = colorseqcount + 0x80;
							RLEdata[bmplength + 2] = prevpalette;
							bmplength += 3;
						}
					}
					else
					{
						RLEdata[bmplength] = 0x00;
						RLEdata[bmplength + 1] = colorseqcount;
						bmplength += 2;
					}
				}
				prevpalette = j;
				colorseqcount = 1;
			}
		}
		j = (double)colorseqcount / 256;
		if(colorseqcount >= 0x40)
		{
			if(prevpalette != 0)
			{
				RLEdata[bmplength] = 0x00;
				RLEdata[bmplength + 1] = j + 0xC0;
				RLEdata[bmplength + 2] = colorseqcount - j * 256;
				RLEdata[bmplength + 3] = prevpalette;
				bmplength += 4;
			}
			else
			{
				RLEdata[bmplength] = 0x00;
				RLEdata[bmplength + 1] = j + 0x40;
				RLEdata[bmplength + 2] = colorseqcount - j * 256;
				bmplength += 3;
			}
		}
		else
		{
			if(prevpalette != 0)
			{
				if(prevpalette <= 0x39 && colorseqcount == 1)
				{
					RLEdata[bmplength] = prevpalette;
					bmplength += 1;
				}
				else if(prevpalette <= 0x39 && colorseqcount == 2)
				{
					RLEdata[bmplength] = prevpalette;
					RLEdata[bmplength + 1] = prevpalette;
					bmplength += 2;
				}
				else
				{
					RLEdata[bmplength] = 0x00;
					RLEdata[bmplength + 1] = colorseqcount + 0x80;
					RLEdata[bmplength + 2] = prevpalette;
					bmplength += 3;
				}
			}
			else
			{
				RLEdata[bmplength] = 0x00;
				RLEdata[bmplength + 1] = colorseqcount;
				bmplength += 2;
			}
		}
		RLEdata[bmplength] = 0x00;
		RLEdata[bmplength + 1] = 0x00;
		bmplength += 2;
	}
	if((bmplength + 11) > 65535)
	{
		printf("Error: subtitle picture is very complicated. (%d byte)\n", bmplength);
		printf("       It should be less than 65537 bytes.\n");
		getch();
		return(0);
	}
	return bmplength;
}

void write_bitmap_def(FILE* ofp)
{
	// 0x15
	bitmap_def.PTS = be32(time3);
	bitmap_def.DTS = be32(time1);
	bitmap_def.png_w = be16(png_w);
	bitmap_def.png_h = be16(png_h);

	bitmap_def.bmplength = be16(bmplength + 11);
	bitmap_def.bmplength2 = be16(bmplength + 11 -7);

	fwrite(&bitmap_def, 1, sizeof(bitmap_def), ofp);
	fwrite(RLEdata, 1, bmplength, ofp);
}

void write_displayset_end1(FILE* ofp)
{
	// 0x80
	displayset_end.PTS = be32(time3);
	displayset_end.DTS = 0;

	fwrite(&displayset_end, 1, sizeof(displayset_end), ofp);
}

void write_present_def2(FILE *ofp)
{
	// 0x16
	present_def.PTS = be32(endtime);
	present_def.DTS = be32(time4);			//endtime -90
	present_def.width = be16(width);
	present_def.height = be16(height);
			
	//something internal issue
	present_def.sect_size = be16(0x000b);	// 0x0013
	present_def.reserved_2 = be16(0x0001);
	present_def.reserved_3 = 0x0000;
	present_def.reserved_5 = 0x00000000;	// erase??

	fwrite(&present_def, 1, sizeof(present_def)-(0x13-0x0b), ofp);
}

void write_window_def2(FILE *ofp)
{
	// 0x17
	window_def.PTS = be32(time4);
	window_def.DTS = 0;
	window_def.offsetx = be16(offsetx);
	window_def.offsety = be16(offsety);
	window_def.png_w = be16(png_w);
	window_def.png_h = be16(png_h);

	fwrite(&window_def, 1, sizeof(window_def), ofp);
}

void write_displayset_end2(FILE* ofp)
{
	// 0x80
	displayset_end.PTS = be32(time4);
	displayset_end.DTS = 0;

	fwrite(&displayset_end, 1, sizeof(displayset_end), ofp);
}


